package core;

import java.io.Serializable;
import java.security.SecureRandom;

import sun.misc.BASE64Encoder;

/**
 * This class represents a Nonce
 * @author Xavier Didelot
 */
public class Nonce extends Message implements INonce,Serializable {

	/**
	 * This method creates a Nonce containing the given string
	 * @param string content of the Nonce to be created
	 */

	/**
	 * The id of this Nonce used in the protocol description (for example Na or Nb)
	 */
	private String id;
	
	public Nonce(String string) {
		super();
		setString(string);
	}

	public Nonce() {
		super();
		id = "";
	}

	/**
	 * This method creates a fresh Nonce of 10 bytes and returns a message containing a Base64 string
	 */
	public Nonce(Integer b) {
		SecureRandom sr = new SecureRandom();
		byte[] pseudoRandom = new byte[10];
		sr.nextBytes(pseudoRandom);
		BASE64Encoder encoder = new BASE64Encoder();
		String result = encoder.encode(pseudoRandom);
		setString(result);
	}

	/**
	 * Creates a copy of the Nonce
	 * @see java.lang.Object#clone()
	 */
	protected Object clone() throws CloneNotSupportedException {
		return super.clone();
	}

	/**
	 * Return the Id of this Nonce
	 * @return the Id of this Nonce
	 */
	public String getId() {
		return id;
	}

	/**
	 * Set the Id of this Nonce
	 * @param string the new Id of this Nonce
	 */
	public void setId(String string) {
		id = string;
	}

}
