package protocols;

import core.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.lang.reflect.Array;
import java.io.ObjectOutputStream;
import java.io.ByteArrayOutputStream;
import java.math.BigInteger;

public class SERVYAHA2 extends Protocol {
   
   public SERVYAHA2 (ObjectOutputStream oos) {
      super("core.Message" ,"core.MessageKey" ,"core.Nonce" );
      this.oos=oos;
      }
   
   public void run() {
      try {
         IMessageKey kab = null;
         
         println("creating DESkey kab");
         kab = messageKey("DES");
         
         println("waiting for m2");
         Message m2 = message(get("b",4002));
         println("Decrypting m2");
         m2.decrypt("DES", getSecretKey("b"));
         addParts(m2.getAllFields(),5);
         m0=getPart();
         setNameToId(m0.getString(),"a");
         m0=getPart();
         setNameToId(m0.getString(),"b");
         m0=getPart();
         setIPToId(m0.getString(),"a");
         m0=getPart();
         setValueToNonce(m0.getString(),"na");
         m0=getPart();
         setValueToNonce(m0.getString(),"nb");
         
         
         println("Building message m3");
         Message m3 =message();
         m0=message();
         m0.addMessage(message(agentFromId("b")));
         m0.addMessage(message(kab.getString()));
         m0.addMessage(message(nonceFromId("na")));
         m0.addMessage(message(nonceFromId("nb")));
         println("Encrypting m0");
         m0.encrypt("DES", getSecretKey("a"));
         m3.addMessage(m0);
         m0=message();
         m0.addMessage(message(agentFromId("a")));
         m0.addMessage(message(kab.getString()));
         println("Encrypting m0");
         m0.encrypt("DES", getSecretKey("b"));
         m3.addMessage(m0);
         println("Sending message m3");
         put("a", m3.getString(),4001);
         
         
         } catch (Exception e) {e.printStackTrace();System.exit(0);}
      }
   
   public static void subMain(String[] args,ObjectOutputStream oos) {
      SERVYAHA2 s;
      while (true) {
         s=new SERVYAHA2(oos);
         args=s.getArgs(args);
         s.newAgent("b",4002);
         s.start();
         }
      }
   
   public String[] getArgs(String[] args) {
      try {
         if (args.length != 2) {
            args = (String[]) Array.newInstance("".getClass(), 2);
            BufferedReader in2 =
            new BufferedReader(new InputStreamReader(System.in));
            println("Type the SecretKeyStore file to use [secretkeystore]");
            args[0]=in2.readLine();
            if (args[0].compareTo("")==0) args[0]="secretkeystore";
            println("Type the name of agent s [s]");
            args[1]=in2.readLine();
            if (args[1].compareTo("")==0) args[1]="s";
            }
         setSKS(args[0]);
         setNameToId(args[1],"s");
         } catch (Exception e) {e.printStackTrace();}
      return args;
      }
   
   public static void main(String[] args) {
      ObjectOutputStream oos=null;
      try {
         ByteArrayOutputStream os = new ByteArrayOutputStream();
         oos=new ObjectOutputStream(os);
         PrintOOS p=new PrintOOS("SERVYAHA2",oos,os);
         p.start();}
      catch (Exception e) {e.printStackTrace();}
      subMain(args,oos);
      }
   }